# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define	section		free

Name:		howl-logger
Summary:	High speed ObjectWeb logger
Url:		http://howl.objectweb.org/
Version:	0.1.11
Release:	1jpp
Epoch:		0
License:	Apache Software License 2
Group:		Development/Libraries/Java
Vendor:		JPackage Project
Distribution:	JPackage
BuildArch:	noarch
Source0:	howl-logger-%{version}-src.tar.gz
# cvs -d:pserver:anonymous@cvs.forge.objectweb.org:/cvsroot/howl login
# cvs -z3 -d:pserver:anonymous@cvs.forge.objectweb.org:/cvsroot/howl export -r HOWL_0_1_11 howl/logger
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:	howl-logger-%{version}-jpp-depmap.xml
Patch0:		howl-logger-%{version}-jpp.patch

BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:	ant >= 0:1.6
BuildRequires:	junit >= 0:3.8.1
BuildRequires:	maven >= 0:1.1
BuildRequires:	saxon-scripts
BuildRequires:	emma
#
#
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
HOWL is a logger implementation providing features 
required by the ObjectWeb JOTM project, with a public 
API that is generally usable by any Transaction Manager. 
HOWL uses unformatted binary logs to maximize performance 
and specifies a journalization API with methods necessary 
to support JOTM recovery operations. 

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n logger
chmod -R go=u-w *
find . -name "*.jar" -exec rm -f {} \;
export DEPCAT=$(pwd)/howl-logger-%{version}-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > howl-logger-%{version}-depmap.new.xml

%patch0 -b .sav

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
export JAVA_HOME

maven \
	-Dmaven.home.local=$(pwd)/.maven \
	-Dmaven.repo.remote=file:/usr/share/maven/repository \
	-Dmaven.test.failure.ignore=true \
	-Dmaven.javadoc.source=1.4 \
	jar:jar javadoc:generate

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{name}-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc LICENSE.txt
%{_javadir}/*

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Thu Jul 20 2006 Ralph Apel <r.apel at r-apel.de> 0:0.1.11-1jpp
- First JPP-1.7 release
- Upgrade to 0.1.11 as required by jonas-4.7.5

* Fri Mar 04 2005 Fernando Nasser <fnasser@redhat.com> 0:0.1.8-1jpp
- Add missing build dependency on saxon-scripts
- Upgrade to 0.1.8

* Tue Feb 01 2005 Ralph Apel <r.apel at r-apel.de> 0:0.1.7-2jpp
- Process project.xml files with saxon
- Don't tamper with $HOME
- Don't use build-jar-repository; explicitly ln -sf $(build-classpath ...)

* Mon Oct 11 2004 Ralph Apel <r.apel at r-apel.de> 0:0.1.7-1jpp
- First release

